<template>
    <ag-grid-vue
        :class="theme"
        :gridOptions="optionsExtended"
        :rowData="rowData"
        readOnlyEdit
        pagination
        style="height: 100%"
    >
    </ag-grid-vue>
</template>

<script setup lang="ts">
import { ref, watch } from 'vue'
import { AgGridVue } from 'ag-grid-vue3'
import { GridOptions } from 'ag-grid-community'
import { useGlobalStore } from '@/stores/globalStore'
import { ymdhm } from '@/helpers/dateFormat'
import gridLocale from '@/helpers/gridLocale'

import 'ag-grid-community/styles/ag-grid.css'
import 'ag-grid-community/styles/ag-theme-quartz.css'

// GRID

const props = defineProps<{
    options: GridOptions
    rowData: any
}>()

const optionsExtended = props.options

optionsExtended.columnTypes = {
    ...optionsExtended.columnTypes,
    date: {
        width: 160,
        valueFormatter: (v) => ymdhm(v.value),
    },
    device: {
        valueFormatter: (val) =>
            [val.value?.name, val.value?.ip, val.value?.mac]
                .filter((v) => Boolean(v))
                .join(', '),
    },
}

optionsExtended.localeText = gridLocale

if (!optionsExtended.getRowId) {
    optionsExtended.getRowId = (params) => params.data?.id
}

if (!optionsExtended.defaultColDef) {
    optionsExtended.defaultColDef = { filter: true }
}

// Dark mode
const globalStore = useGlobalStore()

const theme = ref(
    globalStore.darkMode ? 'ag-theme-quartz-dark' : 'ag-theme-quartz'
)
watch(
    globalStore,
    (val) =>
        (theme.value = val.darkMode
            ? 'ag-theme-quartz-dark'
            : 'ag-theme-quartz')
)
</script>
